## python-rtmidi 1.1.0

=== Makefile ===
.PHONY: clean-pyc clean-build docs clean

PYTHON ?= python
SOURCES = src/_rtmidi.cpp src/RtMidi.cpp

help:
	@echo "build - build extension module (and place it in the rtmidi package)"
	@echo "clean-build - remove build artifacts"
	@echo "clean-docs - remove docs output"
	@echo "clean-pyc - remove Python file artifacts"
	@echo "lint - check style with flake8"
	@echo "check-docs - check docstrings with pycodestyle"
	@echo "test - run tests with the default Python against working dir"
	@echo "test-all - run tests on every Python version with tox"
	@echo "coverage - check code coverage quickly with the default Python"
	@echo "docs - generate Sphinx HTML documentation, including API docs"
	@echo "release - package and upload a release"
	@echo "dist - build distribution packages"

build: $(SOURCES)
	$(PYTHON) setup.py build_ext --inplace

clean: clean-build clean-docs clean-pyc
	rm -fr htmlcov/

clean-build:
	rm -fr build/
	rm -fr dist/
	rm -fr *.egg-info
	rm -fr rtmidi/*.so
	rm -fr src/_rtmidi.cpp

clean-docs:
	rm -fr docs/_build

clean-pyc:
	find . -name '*.pyc' -exec rm -f {} +
	find . -name '*.pyo' -exec rm -f {} +
	find . -name '*~' -exec rm -f {} +
	find . -name __pycache__ -type d -exec rm -rf {} +

lint:
	flake8 rtmidi tests examples

check-docs:
	pydocstyle rtmidi src

test:
	PYTHONPATH=examples $(PYTHON) setup.py test

test-all:
	tox

coverage:
	coverage run --source rtmidi setup.py test
	coverage report -m
	coverage html
	xdg-open htmlcov/index.html

docs: release
	rm -f docs/rtmidi.rst
	rm -f docs/modules.rst
	$(PYTHON) setup.py build_ext --inplace
	sphinx-apidoc -o docs/ rtmidi
	cat docs/classes.rst >> docs/rtmidi.rst
	$(MAKE) -C docs clean
	$(MAKE) -C docs html
	xdg-open docs/_build/html/index.html

release: clean
	$(PYTHON) setup.py release

release_upload: clean
	$(PYTHON) setup.py release_upload

dist: clean release
	ls -l dist

=== debian/changelog ===
python-rtmidi (1.1.0-2) unstable; urgency=medium

  * debian/control:
    - Bumps dependency librtmidi3 -> librtmidi4 (Closes: #880848)
    - Bumps debhelper compat from 9 to 10.
  * Bumps Standards-Version to 4.1.1:
    - Changes extra package priority to optional.

 -- Josue Ortega <josue@debian.org>  Sat, 25 Nov 2017 08:24:34 -0600

python-rtmidi (1.1.0-1) unstable; urgency=low

  * Initial release. (Closes: #825143)

 -- Josue Ortega <josue@debian.org>  Sun, 16 Jul 2017 17:43:42 -0600

=== debian/control ===
Source: python-rtmidi
Section: python
Priority: optional
Maintainer: Josue Ortega <josue@debian.org>
Build-Depends: debhelper (>=10),
 dh-python,
 python3-all,
 python3-all-dev,
 python3-setuptools,
 cython3 (>= 0.25.2),
 libasound-dev,
 libjack-dev,
 librtmidi-dev,
 python3-pytest,
 python3-mock
Standards-Version: 4.1.1
Homepage: http://trac.chrisarndt.de/code/wiki/python-rtmidi
Vcs-Git: https://anonscm.debian.org/git/collab-maint/python-rtmidi.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/python-rtmidi.git

Package: python3-rtmidi
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
 librtmidi4
Suggests: libjack0,
 libasound2
Description: Python wrapper for the RtMidi C++ library written with Cython
 Python binding for RtMidi implemented with Cython and provides a thin wrapper
 around the RtMidi C++ interface. The API is basically the same as the C++ one
 but with the naming scheme of classes, methods and parameters adapted to the
 Python naming structure.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME=rtmidi

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_clean:
	rm -f $(CURDIR)/src/_rtmidi.cpp
	rm -f $(CURDIR)/rtmidi/*.so
	rm -rf $(CURDIR)/python_rtmidi.egg-info
	dh_auto_clean

override_dh_auto_test:
#Overrides auto_test due to `/dev/snd/seq` is not available during
#build in a chroot enviroment

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/python-rtmidi-$1\.tar\.gz/ \
  https://github.com/SpotlightKid/python-rtmidi/releases .*/v*(\d\S*)\.tar\.gz

## python-rtmidi 1.2.1

=== Makefile ===
.PHONY: clean-pyc clean-build docs clean

PYTHON ?= python
SOURCES = src/_rtmidi.cpp src/RtMidi.cpp

help:
	@echo "build - build extension module (and place it in the rtmidi package)"
	@echo "check-docs - check docstrings with pycodestyle"
	@echo "clean-build - remove build artifacts"
	@echo "clean-docs - remove docs output"
	@echo "clean-pyc - remove Python file artifacts"
	@echo "coverage - check code coverage quickly with the default Python"
	@echo "dist - build distribution packages"
	@echo "docs - generate Sphinx HTML documentation, including API docs"
	@echo "lint - check style with flake8"
	@echo "release - package a release"
	@echo "release_upload - package a release and upload it to PyPI"
	@echo "test - run tests on every supported Python version with tox"

build: $(SOURCES)
	$(PYTHON) setup.py build_ext --inplace

check-docs:
	pydocstyle rtmidi src

clean: clean-build clean-docs clean-pyc
	rm -fr htmlcov/

clean-build:
	rm -fr build/
	rm -fr dist/
	rm -fr *.egg-info
	rm -fr rtmidi/*.so
	rm -fr src/_rtmidi.cpp

clean-docs:
	rm -fr docs/_build

clean-pyc:
	find . -name '*.pyc' -exec rm -f {} +
	find . -name '*.pyo' -exec rm -f {} +
	find . -name '*~' -exec rm -f {} +
	find . -name __pycache__ -type d -exec rm -rf {} +

coverage:
	coverage run --source rtmidi setup.py test
	coverage report -m
	coverage html
	xdg-open htmlcov/index.html

dist: clean release
	ls -l dist

docs: release
	rm -f docs/rtmidi.rst
	rm -f docs/modules.rst
	$(PYTHON) setup.py build_ext --inplace
	sphinx-apidoc -o docs/ rtmidi rtmidi/release.py
	cat docs/api.rst.inc >> docs/rtmidi.rst
	$(MAKE) -C docs clean
	$(MAKE) -C docs html
	xdg-open docs/_build/html/index.html

lint:
	flake8 rtmidi tests examples

release: clean
	$(PYTHON) setup.py release

release_upload: release
	twine upload --skip-existing dist/*.whl dist/*.tar.gz

test:
	PYTHONPATH=examples $(PYTHON) setup.py test

=== debian/changelog ===
python-rtmidi (1.2.1-1build2) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:24:10 +0100

python-rtmidi (1.2.1-1build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2019 18:43:44 +0000

python-rtmidi (1.2.1-1) unstable; urgency=medium

  [ Nicolas Boulenguez ]
  * Revert to the embedded RtMidi, explain why in README.source.
  * Fix upstream version in this changelog (remove ~).
  * Add forgotten Rules-Requires-Root: no field.
  * Let the run time test check a C call in addition to basic import.
    Prevent the rtmidi subdirectory hiding the installed one.

  [ Josue Ortega ]
  * New upstream release. (1.2.1):
    - Update debian/copyright for files under `src/rtmidi`.
  * debian/watch: Updated to use Pypi since Github tarball does not include
    properly the `src` directory.
  * debian/copyright: Update copyright holders years.

 -- Josue Ortega <josue@debian.org>  Wed, 06 Feb 2019 18:44:43 -0600

python-rtmidi (1.2.0~rc1-2) unstable; urgency=medium

  [ Nicolas Boulenguez ]
  * debian/control:
    - Add Rules-Requires-Root: no.
    - Drop unnecessary dependencies.
  * Update copyright years.
  * Use the packaged rtmidi instead of an embedded copy. (Closes: #883709)
  * debian/rules: add Link with --as-needed flag.

 -- Josue Ortega <josue@debian.org>  Sat, 29 Dec 2018 07:03:23 -0600

python-rtmidi (1.2.0~rc1-1) unstable; urgency=medium

  * New upstream release. (1.2.0rc1)
  * Remove Build Dependency on librtmidi-dev, since it is not needed at
    build time (Closes: #883709).
  * debian/control: Update Vcs-* fields to use salsa.debian.org.
  * Bump debhelper compat level to 11.
  * Add package examples to installation.
  * Bump Standards-Version to 4.3.0, no changes were required.
  * Add CI tests.

 -- Josue Ortega <josue@debian.org>  Fri, 28 Dec 2018 15:04:12 -0600

=== debian/control ===
Source: python-rtmidi
Section: python
Priority: optional
Maintainer: Josue Ortega <josue@debian.org>
Build-Depends:
 debhelper (>= 11),
 dh-python,
 python3-all,
 python3-all-dev,
 python3-setuptools,
 cython3 (>= 0.25.2),
 libasound-dev,
 libjack-dev,
 python3-pytest,
 python3-mock
Standards-Version: 4.3.0
Rules-Requires-Root: no
Homepage: http://trac.chrisarndt.de/code/wiki/python-rtmidi
Vcs-Git: https://salsa.debian.org/debian/python-rtmidi.git
Vcs-Browser: https://salsa.debian.org/debian/python-rtmidi

Package: python3-rtmidi
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: Python wrapper for the RtMidi C++ library written with Cython
 Python binding for RtMidi implemented with Cython and provides a thin wrapper
 around the RtMidi C++ interface. The API is basically the same as the C++ one
 but with the naming scheme of classes, methods and parameters adapted to the
 Python naming structure.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME=rtmidi

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_clean:
	dh_clean src/_rtmidi.cpp python_rtmidi.egg-info/

override_dh_auto_test:
#Overrides auto_test due to `/dev/snd/seq` is not available during
#build in a chroot enviroment

=== debian/watch ===
version=3
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/python-rtmidi/python-rtmidi-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## python-rtmidi 1.4.7

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 .PHONY: clean-pyc clean-build docs clean
 
 PYTHON ?= python
-SOURCES = src/_rtmidi.cpp src/RtMidi.cpp
+SOURCES = src/_rtmidi.pyx src/rtmidi/RtMidi.cpp
 
 help:
 	@echo "build - build extension module (and place it in the rtmidi package)"
@@ -68,7 +68,7 @@
 	$(PYTHON) setup.py release
 
 release_upload: release
-	twine upload --skip-existing dist/*.whl dist/*.tar.gz
+	twine upload --skip-existing dist/*.tar.gz
 
 test:
 	PYTHONPATH=examples $(PYTHON) setup.py test

=== debian/changelog ===
python-rtmidi (1.4.7-1) unstable; urgency=medium

  * New upstream release (1.4.7)
  * Declare package Standards Version to be 4.5.1. No changes were
    required
  * debian/watch: Bump file standard version to 4
  * debian/rules: Remove -Wl, --as-needed linker flags since it is not
    necessary anymore for bullseye distribution

 -- Josue Ortega <josue@debian.org>  Mon, 01 Feb 2021 19:34:50 -0600

python-rtmidi (1.4.5-1) unstable; urgency=medium

  * New upstream release (1.4.5)
  * Switch package to use debhelper-compat (= 13)
  * Bump Standards-Version to 4.5.0. No changes required

 -- Josue Ortega <josue@debian.org>  Sun, 04 Oct 2020 14:34:15 -0600

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Josue Ortega <josue@debian.org>
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 13),
  dh-python,
  python3-all,
  python3-all-dev,
@@ -13,7 +13,7 @@
  libjack-dev,
  python3-pytest,
  python3-mock
-Standards-Version: 4.3.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: http://trac.chrisarndt.de/code/wiki/python-rtmidi
 Vcs-Git: https://salsa.debian.org/debian/python-rtmidi.git

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,6 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE = 1
 
-export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export PYBUILD_NAME=rtmidi

## python-rtmidi 1.5.8

=== Makefile ===
.PHONY: clean-pyc clean-build clean coverage docs dist lint release release_upload requirements test

BUILDDIR ?= builddir
PREFIX ?= /usr/local
PYTHON ?= python3
SOURCES = src/_rtmidi.pyx src/rtmidi/RtMidi.cpp

help:
	@echo "build - build extension module (and place it in the rtmidi package)"
	@echo "check-docs - check docstrings with pycodestyle"
	@echo "clean-build - remove build artifacts"
	@echo "clean-docs - remove docs output"
	@echo "clean-pyc - remove Python file artifacts"
	@echo "coverage - check code coverage quickly with the default Python"
	@echo "dist - build distribution packages"
	@echo "docs - generate Sphinx HTML documentation, including API docs"
	@echo "lint - check style with flake8"
	@echo "release - package a release"
	@echo "release_upload - package a release and upload it to PyPI"
	@echo "requirements - generate 'requirement-dev.txt' from 'requirements-dev.in'"
	@echo "test - run tests with pytest"

build: $(SOURCES)
	if [[ -d "$(BUILDDIR)" ]]; then \
		meson setup --reconfigure "--prefix=$(PREFIX)" -Dbuildtype=plain $(BUILDDIR); \
	else \
		meson setup "--prefix=$(PREFIX)" -Dbuildtype=plain $(BUILDDIR); \
	fi
	meson compile -C $(BUILDDIR)

check-docs:
	$(PYTHON) -m pydocstyle rtmidi

clean: clean-build clean-docs clean-pyc
	rm -fr htmlcov/

clean-build:
	rm -fr dist/
	rm -fr *.egg-info
	rm -fr rtmidi/*.so
	rm -fr src/_rtmidi.cpp

clean-docs:
	rm -fr docs/_build

clean-pyc:
	find . -name '*.pyc' -exec rm -f {} +
	find . -name '*.pyo' -exec rm -f {} +
	find . -name '*~' -exec rm -f {} +
	find . -name __pycache__ -type d -exec rm -rf {} +

coverage: build
	cp -f $(BUILDDIR)/rtmidi/_rtmidi.*.so rtmidi/
	cp -f $(BUILDDIR)/rtmidi/version.py rtmidi/
	$(PYTHON) -m coverage run --source rtmidi -m pytest tests
	$(PYTHON) -m coverage report -m
	$(PYTHON) -m coverage html
	-rm -f rtmidi/*.so rtmidi/version.py
	-xdg-open htmlcov/index.html

dist: clean release
	ls -l dist

docs: build
	cp -f $(BUILDDIR)/rtmidi/_rtmidi.*.so rtmidi/
	cp -f $(BUILDDIR)/rtmidi/version.py rtmidi/
	rm -f docs/rtmidi.rst
	rm -f docs/modules.rst
	sphinx-apidoc -o docs rtmidi
	cat docs/api.rst.inc >> docs/rtmidi.rst
	$(MAKE) -C docs clean
	$(MAKE) -C docs html
	-rm -f rtmidi/*.so rtmidi/version.py
	-xdg-open docs/_build/html/index.html

lint:
	$(PYTHON) -m flake8 rtmidi tests examples

release:
	$(PYTHON) -m build

release_upload: release
	$(PYTHON) -m twine upload --skip-existing dist/*.tar.gz dist/*.whl

requirements-dev.txt: requirements-dev.in
	pip-compile --quiet --resolver=backtracking --no-emit-index-url --strip-extras "$<" > "$@"

requirements: requirements-dev.txt

test:
	pytest -v tests

=== meson_options.txt ===
option('alsa',
    type: 'boolean',
    value: true,
    description: 'Enable ALSA MIDI support'
)
option('coremidi',
    type: 'boolean',
    value: true,
    description: 'Enable CoreMIDI support'
)
option('jack',
    type: 'boolean',
    value: true,
    description: 'Enable JACK MIDI support'
)
option('python',
    type: 'string',
    value: 'python3',
    description: 'Set name (or path) of Python interpreter'
)
option('verbose',
    type: 'boolean',
    value: false,
    description: 'Turn on debug logging (for development)'
)
option('wheel',
    type: 'boolean',
    value: false,
    description: 'Turn on build mode for creating a Python wheel (should not be used directly)'
)
option('winmm',
    type: 'boolean',
    value: true,
    description: 'Enable Windows MultiMedia support'
)

=== src/rtmidi/CMakeLists.txt ===
# 2018 (c) Juan G. Victores, Bartek Łukawski, Stephen Sinclair
# CopyPolicy: RtMidi license.

# Set minimum CMake required version for this project.
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

# Define a C++ project.
project(RtMidi LANGUAGES CXX C)

# standards version
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Check for Jack (any OS)
find_library(JACK_LIB jack)
find_package(PkgConfig)
pkg_check_modules(jack jack)
if(JACK_LIB OR jack_FOUND)
  set(HAVE_JACK TRUE)
endif()

# Necessary for Windows
if(WIN32)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

# Standard CMake options
option(BUILD_SHARED_LIBS "Build as shared library" ON)

if (NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug;Release;RelWithDebInfo;MinSizeRel")
endif()
if(WINDOWS)
  set(CMAKE_DEBUG_POSTFIX d CACHE STRING "Postfix for debug version of library")
endif()

# Build Options
set(RTMIDI_TARGETNAME_UNINSTALL "uninstall" CACHE STRING "Name of 'uninstall' build target")

# API Options
option(RTMIDI_API_JACK "Compile with JACK support." ${HAVE_JACK})
if(UNIX AND NOT APPLE)
  option(RTMIDI_API_ALSA "Compile with ALSA support." ON)
endif()
option(RTMIDI_API_WINMM "Compile with WINMM support." ${WIN32})
option(RTMIDI_API_CORE "Compile with CoreMIDI support." ${APPLE})

# Add -Wall if possible
if (CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif (CMAKE_COMPILER_IS_GNUCXX)

# Add debug flags
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_definitions(-D__RTMIDI_DEBUG__)
  if (CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
  endif (CMAKE_COMPILER_IS_GNUCXX)
endif ()

# Read libtool version info from configure.ac
set(R "m4_define\\(\\[lt_([a-z]+)\\], ([0-9]+)\\)")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/configure.ac" CONFIGAC
  REGEX ${R})
foreach(_S ${CONFIGAC})
  string(REGEX REPLACE ${R} "\\1" k ${_S})
  string(REGEX REPLACE ${R} "\\2" v ${_S})
  set(SO_${k} ${v})
endforeach()
math(EXPR SO_current_minus_age "${SO_current} - ${SO_age}")
set(SO_VER "${SO_current_minus_age}")
set(FULL_VER "${SO_current_minus_age}.${SO_age}.${SO_revision}")

# Read package version info from configure.ac
set(R "AC_INIT\\(RtMidi, ([0-9\\.]+),.*\\)")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/configure.ac" CONFIGAC
  REGEX ${R})
string(REGEX REPLACE ${R} "\\1" PACKAGE_VERSION ${CONFIGAC})

# Init variables
set(rtmidi_SOURCES RtMidi.cpp RtMidi.h rtmidi_c.cpp rtmidi_c.h)
set(LINKLIBS)
set(PUBLICLINKLIBS)
set(INCDIRS)
set(PKGCONFIG_REQUIRES)
set(LIBS_REQUIRES)
set(API_DEFS)
set(API_LIST)
set(PACKAGE_DEPENDENCIES)

# Tweak API-specific configuration.

# Jack
if(RTMIDI_API_JACK)
  if (NOT HAVE_JACK)
    message(FATAL_ERROR "Jack API requested but no Jack dev libraries found")
  endif()
  set(NEED_PTHREAD ON)
  list(APPEND PKGCONFIG_REQUIRES "jack")
  list(APPEND API_DEFS "-D__UNIX_JACK__")
  list(APPEND API_LIST "jack")
  if(jack_FOUND)
    list(APPEND LINKLIBS ${jack_LIBRARIES})
    list(APPEND INCDIRS ${jack_INCLUDEDIR})
  else()
    list(APPEND LINKLIBS ${JACK_LIB})
  endif()

  # Check for jack_port_rename
  include(CheckSymbolExists)
  set(tmp_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
  list(APPEND CMAKE_REQUIRED_LIBRARIES jack)
  check_symbol_exists(jack_port_rename ${jack_INCLUDEDIR}/jack/jack.h JACK_HAS_PORT_RENAME)
  set(CMAKE_REQUIRED_LIBRARIES ${tmp_CMAKE_REQUIRED_LIBRARIES})
  if(JACK_HAS_PORT_RENAME)
    list(APPEND API_DEFS "-DJACK_HAS_PORT_RENAME")
  endif()
endif()

# ALSA
if(RTMIDI_API_ALSA)
  set(NEED_PTHREAD ON)
  find_package(ALSA)
  if (NOT ALSA_FOUND)
    message(FATAL_ERROR "ALSA API requested but no ALSA dev libraries found")
  endif()
  list(APPEND INCDIRS ${ALSA_INCLUDE_DIR})
  list(APPEND LINKLIBS ALSA::ALSA)
  list(APPEND PKGCONFIG_REQUIRES "alsa")
  list(APPEND API_DEFS "-D__LINUX_ALSA__")
  list(APPEND API_LIST "alsa")
  list(APPEND PACKAGE_DEPENDENCIES "find_dependency(ALSA)")
endif()

# WinMM
if(RTMIDI_API_WINMM)
  list(APPEND API_DEFS "-D__WINDOWS_MM__")
  list(APPEND API_LIST "winmm")
  list(APPEND LINKLIBS winmm)
endif()

# CoreMIDI
if(RTMIDI_API_CORE)
  find_library(CORESERVICES_LIB CoreServices)
  find_library(COREAUDIO_LIB CoreAudio)
  find_library(COREMIDI_LIB CoreMIDI)
  find_library(COREFOUNDATION_LIB CoreFoundation)
  list(APPEND API_DEFS "-D__MACOSX_CORE__")
  list(APPEND API_LIST "coremidi")
  list(APPEND LINKLIBS ${CORESERVICES_LIB} ${COREAUDIO_LIB} ${COREMIDI_LIB} ${COREFOUNDATION_LIB})
  list(APPEND LIBS_REQUIRES "-framework CoreServices -framework CoreAudio -framework CoreMIDI -framework CoreFoundation")
  list(APPEND LINKFLAGS "-Wl,-F/Library/Frameworks")
endif()

# pthread
if (NEED_PTHREAD)
  find_package(Threads REQUIRED
    CMAKE_THREAD_PREFER_PTHREAD
    THREADS_PREFER_PTHREAD_FLAG)
  list(APPEND PUBLICLINKLIBS Threads::Threads)
  list(APPEND PACKAGE_DEPENDENCIES "find_dependency(Threads)")
endif()

# Create library targets.
set(LIB_TARGETS)

# Use RTMIDI_BUILD_SHARED_LIBS / RTMIDI_BUILD_STATIC_LIBS if they
# are defined, otherwise default to standard BUILD_SHARED_LIBS.
if (DEFINED RTMIDI_BUILD_SHARED_LIBS AND NOT RTMIDI_BUILD_SHARED_LIBS STREQUAL "")
  if (RTMIDI_BUILD_SHARED_LIBS)
    add_library(rtmidi SHARED ${rtmidi_SOURCES})
  else()
    add_library(rtmidi STATIC ${rtmidi_SOURCES})
  endif()
elseif (DEFINED RTMIDI_BUILD_STATIC_LIBS AND NOT RTMIDI_BUILD_STATIC_LIBS STREQUAL "")
  if (RTMIDI_BUILD_STATIC_LIBS)
    add_library(rtmidi STATIC ${rtmidi_SOURCES})
  else()
    add_library(rtmidi SHARED ${rtmidi_SOURCES})
  endif()
else()
  add_library(rtmidi ${rtmidi_SOURCES})
endif()
list(APPEND LIB_TARGETS rtmidi)

# Add headers destination for install rule.
set_property(TARGET rtmidi PROPERTY PUBLIC_HEADER RtMidi.h rtmidi_c.h)
set_target_properties(rtmidi PROPERTIES
  SOVERSION ${SO_VER}
  VERSION ${FULL_VER})

# Set standard installation directories.
include(GNUInstallDirs)

# Set include paths, populate target interface.
target_include_directories(rtmidi PRIVATE ${INCDIRS}
                                  PUBLIC
                                    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
                                    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

# Set compile-time definitions
target_compile_definitions(rtmidi PRIVATE ${API_DEFS})
target_compile_definitions(rtmidi PRIVATE RTMIDI_EXPORT)
target_link_libraries(rtmidi PUBLIC ${PUBLICLINKLIBS} 
                             PRIVATE ${LINKLIBS})

# Add tests if requested.
option(RTMIDI_BUILD_TESTING "Build test programs" ON)
if (NOT DEFINED RTMIDI_BUILD_TESTING OR RTMIDI_BUILD_TESTING STREQUAL "")
  set(RTMIDI_BUILD_TESTING ${BUILD_TESTING})
endif()
if (RTMIDI_BUILD_TESTING)
  include(CTest)
  add_executable(cmidiin    tests/cmidiin.cpp)
  add_executable(midiclock  tests/midiclock.cpp)
  add_executable(midiout    tests/midiout.cpp)
  add_executable(midiprobe  tests/midiprobe.cpp)
  add_executable(qmidiin    tests/qmidiin.cpp)
  add_executable(sysextest  tests/sysextest.cpp)
  add_executable(apinames   tests/apinames.cpp)
  add_executable(testcapi   tests/testcapi.c)
  list(GET LIB_TARGETS 0 LIBRTMIDI)
  set_target_properties(cmidiin midiclock midiout midiprobe qmidiin sysextest apinames testcapi
    PROPERTIES RUNTIME_OUTPUT_DIRECTORY tests
               INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR}
               LINK_LIBRARIES ${LIBRTMIDI})
  add_test(NAME apinames COMMAND apinames)
endif()

# Set standard installation directories.
include(GNUInstallDirs)

# Message
string(REPLACE ";" " " apilist "${API_LIST}")
message(STATUS "Compiling with support for: ${apilist}")

# PkgConfig file
string(REPLACE ";" " " req "${PKGCONFIG_REQUIRES}")
string(REPLACE ";" " " req_libs "${LIBS_REQUIRES}")
string(REPLACE ";" " " api "${API_DEFS}")
set(prefix ${CMAKE_INSTALL_PREFIX})
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/rtmidi.pc.in" "rtmidi.pc" @ONLY)

# Add install rule.
install(TARGETS ${LIB_TARGETS}
        EXPORT RtMidiTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rtmidi)

# Store the package in the user registry.
export(PACKAGE RtMidi)

# Set installation path for CMake files.
set(RTMIDI_CMAKE_DESTINATION share/rtmidi)

# Export library target (build-tree).
export(EXPORT RtMidiTargets
       NAMESPACE RtMidi::)

# Export library target (install-tree).
install(EXPORT RtMidiTargets
        DESTINATION ${RTMIDI_CMAKE_DESTINATION}
        NAMESPACE RtMidi::)

# Configure uninstall target.
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/RtMidiConfigUninstall.cmake.in"
    "${CMAKE_BINARY_DIR}/RtMidiConfigUninstall.cmake" @ONLY)

# Create uninstall target.
add_custom_target(${RTMIDI_TARGETNAME_UNINSTALL}
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_BINARY_DIR}/RtMidiConfigUninstall.cmake)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/rtmidi.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# Set up CMake package
include(CMakePackageConfigHelpers)

# Write cmake package version file
write_basic_package_version_file(
    rtmidi-config-version.cmake
    VERSION ${FULL_VER}
    COMPATIBILITY SameMajorVersion
)

string(REPLACE ";" "\n" package_dependencies "${PACKAGE_DEPENDENCIES}")

# Write cmake package config file
configure_package_config_file (
    cmake/rtmidi-config.cmake.in
    rtmidi-config.cmake
    INSTALL_DESTINATION "${RTMIDI_CMAKE_DESTINATION}"
)

# Install package files
install (
    FILES
        "${CMAKE_CURRENT_BINARY_DIR}/rtmidi-config.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/rtmidi-config-version.cmake"
    DESTINATION
        "${RTMIDI_CMAKE_DESTINATION}"
)

=== debian/changelog ===
python-rtmidi (1.5.8-3build1) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 12:02:02 +0100

python-rtmidi (1.5.8-3) unstable; urgency=medium

  * debian/control:
    + Remove unused dependency on python3-mock. Thanks to
      Alexandre Detiste <alexandre.detiste@gmail.com> for the fix.
    + Add pybuild-plugin-pyproject and python3-mesonpy as build deps.

 -- Josue Ortega <josue@debian.org>  Mon, 22 Apr 2024 18:49:52 -0600

python-rtmidi (1.5.8-2) unstable; urgency=medium

  * Drop build-dependency on python3-dev-all. (Closes: #1057859)
  * debian/copyright: Update copyright holder year for debian/*.

 -- Josue Ortega <josue@debian.org>  Tue, 02 Jan 2024 11:22:19 -0600

python-rtmidi (1.5.8-1) unstable; urgency=medium

  * New upstream release (1.5.8):
    - This version includes the fix for (no)gil/except declarations on MIDI in
      callback and sendMessage. (Closes: #1056869)
      See: https://github.com/SpotlightKid/python-rtmidi/pull/185/files
  * debian/control:
    - Add python-mesonpy as build dependency.
    - Remove unnecessary restrictions.
    - Update Homepage URL.
  * Bump Standards-Version to 4.6.2. No changes required.
  * debian/copyright: Update copyright holder year for debian/* files.

 -- Josue Ortega <josue@debian.org>  Sun, 03 Dec 2023 10:56:59 -0600

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/python-rtmidi/python-rtmidi-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
